; KeenGrout
; a Keen: Modding Utility
; created by The CK Guy
; for Keen Day 2008

; second release

#Grid_Color = $E0A000
#Background_Color = $206000

Procedure compareDates(f1.s, f2.s)
  d1 = GetFileDate(f1, #PB_Date_Modified)
  d2 = GetFileDate(f2, #PB_Date_Modified)
  If d1 Or d2 : If d1 > d2 : ProcedureReturn 2 : ElseIf d1 = d2 : ProcedureReturn 1 : Else : ProcedureReturn 3 : EndIf : EndIf
EndProcedure

Procedure engroutTiles0(f1.s, f2.s)
  If ReadFile(1, f1) And CreateFile(2, f2)
    ; get dimensions of the input bitmap
    FileSeek(1, $12)
    cols = ReadLong(1) / 16
    rows = ReadLong(1) / 16
    ; write header to output file
    WriteWord(2, $4D42) ; "BM"
    WriteLong(2, 0) ; will be file length
    WriteLong(2, 0) ; reserved
    WriteLong(2, $436) ; offset to bitmap data
    WriteLong(2, $28) ; length of header
    WriteLong(2, cols * 17) ; width of image
    WriteLong(2, rows * 17) ; height of image
    WriteWord(2, 1) ; number of planes (= 1)
    WriteWord(2, 8) ; bits per pixel
    WriteLong(2, 0) ; no compression
    WriteLong(2, 0) ; length of bitmap data (not req'd)
    WriteLong(2, 0) ; horz-resolution (not req'd)
    WriteLong(2, 0) ; vert-resolution (not req'd)
    WriteLong(2, 0) ; colors (not req'd)
    WriteLong(2, 0) ; important colors (not req'd)
    FileSeek(1, $36) : For i = 0 To 15 : WriteLong(2, ReadLong(1)) : Next ; copy palette values from orig
    WriteLong(2, #Grid_Color) ; new grid color (entry # 16)
    For i = 17 To 255 : WriteLong(2, 0) : Next ; rest of palette is black
    If (cols % 4) = 0 : pad = 0 : Else : pad = 4 - ((cols * 17) % 4) : EndIf
    For r = 1 To rows
      For i = 1 To cols * 17 + pad : WriteByte(2, 16) : Next
      For i = 1 To 16
        For c = 1 To cols
          For j = 1 To 8
            n = ReadByte(1) & 255
            WriteByte(2, n >> 4)
            WriteByte(2, n % 16)
          Next
          WriteByte(2, 16)
        Next
        For j = 1 To pad : WriteByte(2, 0) : Next
      Next
    Next
    FileSeek(2, 2)
    WriteLong(2, Lof(2))
    CloseFile(1)
    CloseFile(2)
    SetFileDate(f2, #PB_Date_Modified, GetFileDate(f1, #PB_Date_Modified))
    AddGadgetItem(0, -1, "(en) " + f1)
  EndIf
EndProcedure

Procedure degroutTiles0(f1.s, f2.s)
  If ReadFile(2, f2) And CreateFile(1, f1)
    ; get dimensions of the input bitmap
    FileSeek(2, $12)
    cols = ReadLong(2) / 17
    rows = ReadLong(2) / 17
    ; write header to output file
    WriteWord(1, $4D42) ; "BM"
    WriteLong(1, 0) ; will be file length
    WriteLong(1, 0) ; reserved
    WriteLong(1, $76) ; offset to bitmap data
    WriteLong(1, $28) ; length of header
    WriteLong(1, cols * 16) ; width of image
    WriteLong(1, rows * 16) ; height of image
    WriteWord(1, 1) ; number of planes (= 1)
    WriteWord(1, 4) ; bits per pixel
    WriteLong(1, 0) ; no compression
    WriteLong(1, 0) ; length of bitmap data (not req'd)
    WriteLong(1, 0) ; horz-resolution (not req'd)
    WriteLong(1, 0) ; vert-resolution (not req'd)
    WriteLong(1, 0) ; colors (not req'd)
    WriteLong(1, 0) ; important colors (not req'd)
    FileSeek(2, $36) : For i = 0 To 15 : WriteLong(1, ReadLong(2)) : Next ; copy palette values from orig
    If (cols % 4) = 0 : pad = 0 : Else : pad = 4 - ((cols * 17) % 4) : EndIf
    FileSeek(2, $436)
    For r = 1 To rows
      For i = 1 To cols * 17 + pad : ReadByte(2) : Next
      For i = 1 To 16
        For c = 1 To cols
          For j = 1 To 8 : WriteByte(1, ((ReadByte(2) & 15) << 4) | (ReadByte(2) & 15)) : Next
          ReadByte(2)
        Next
        For j = 1 To pad : ReadByte(2) : Next
      Next
    Next
    FileSeek(1, 2)
    WriteLong(1, Lof(1))
    CloseFile(1)
    CloseFile(2)
    SetFileDate(f1, #PB_Date_Modified, GetFileDate(f2, #PB_Date_Modified))
    AddGadgetItem(0, -1, "(de) " + f1)
  EndIf
EndProcedure

Procedure engroutTiles1(f1.s, f2.s)
  If ReadFile(1, f1) And CreateFile(2, f2)
    ; get dimensions of the input bitmap
    FileSeek(1, $12)
    cols = ReadLong(1) / 32
    rows = ReadLong(1) / 16
    ; write header to output file
    WriteWord(2, $4D42) ; "BM"
    WriteLong(2, 0) ; will be file length
    WriteLong(2, 0) ; reserved
    WriteLong(2, $436) ; offset to bitmap data
    WriteLong(2, $28) ; length of header
    WriteLong(2, cols * 17) ; width of image
    WriteLong(2, rows * 17) ; height of image
    WriteWord(2, 1) ; number of planes (= 1)
    WriteWord(2, 8) ; bits per pixel
    WriteLong(2, 0) ; no compression
    WriteLong(2, 0) ; length of bitmap data (not req'd)
    WriteLong(2, 0) ; horz-resolution (not req'd)
    WriteLong(2, 0) ; vert-resolution (not req'd)
    WriteLong(2, 0) ; colors (not req'd)
    WriteLong(2, 0) ; important colors (not req'd)
    FileSeek(1, $36) : For i = 0 To 15 : WriteLong(2, ReadLong(1)) : Next ; copy palette values from orig
    WriteLong(2, #Background_Color) ; new background color (entry # 16)
    WriteLong(2, #Grid_Color) ; new grid color (entry # 17)
    For i = 18 To 255 : WriteLong(2, 0) : Next ; rest of palette is black
    If (cols % 4) = 0 : pad = 0 : Else : pad = 4 - ((cols * 17) % 4) : EndIf
    For r = 1 To rows
      For i = 1 To cols * 17 + pad : WriteByte(2, 17) : Next
      For i = 1 To 16
        For c = 1 To cols
          For j = 1 To 8
            n = ReadByte(1) & 255
            WriteByte(2, n >> 4)
            WriteByte(2, n % 16)
          Next
          WriteByte(2, 0)
        Next
        FileSeek(2, Loc(2) - cols * 17)
        For c = 1 To cols
          For j = 1 To 8
            n = ReadByte(1) & 255
            If (n >> 4) <> 0 : WriteByte(2, 16) : Else : FileSeek(2, Loc(2) + 1) : EndIf
            If (n % 16) <> 0 : WriteByte(2, 16) : Else : FileSeek(2, Loc(2) + 1) : EndIf
          Next
          WriteByte(2, 17)
        Next
        For j = 1 To pad : WriteByte(2, 0) : Next
      Next
    Next
    FileSeek(2, 2)
    WriteLong(2, Lof(2))
    CloseFile(1)
    CloseFile(2)
    SetFileDate(f2, #PB_Date_Modified, GetFileDate(f1, #PB_Date_Modified))
    AddGadgetItem(0, -1, "(en) " + f1)
  EndIf
EndProcedure

Procedure degroutTiles1(f1.s, f2.s)
  If CreateFile(1, f1) And ReadFile(2, f2)
    ; get dimensions of the input bitmap
    FileSeek(2, $12)
    cols = ReadLong(2) / 17
    rows = ReadLong(2) / 17
    ; write header to output file
    WriteWord(1, $4D42) ; "BM"
    WriteLong(1, 0) ; will be file length
    WriteLong(1, 0) ; reserved
    WriteLong(1, $76) ; offset to bitmap data
    WriteLong(1, $28) ; length of header
    WriteLong(1, cols * 32) ; width of image
    WriteLong(1, rows * 16) ; height of image
    WriteWord(1, 1) ; number of planes (= 1)
    WriteWord(1, 4) ; bits per pixel
    WriteLong(1, 0) ; no compression
    WriteLong(1, 0) ; length of bitmap data (not req'd)
    WriteLong(1, 0) ; horz-resolution (not req'd)
    WriteLong(1, 0) ; vert-resolution (not req'd)
    WriteLong(1, 0) ; colors (not req'd)
    WriteLong(1, 0) ; important colors (not req'd)
    FileSeek(2, $36) : For i = 0 To 15 : WriteLong(1, ReadLong(2)) : Next ; copy palette values from orig
    If (cols % 4) = 0 : pad = 0 : Else : pad = 4 - ((cols * 17) % 4) : EndIf
    FileSeek(2, $436)
    For r = 1 To rows
      For i = 1 To cols * 17 + pad
        ReadByte(2)
      Next
      For i = 1 To 16
        For c = 1 To cols
          For j = 1 To 8 : WriteByte(1, ((ReadByte(2) & 15) << 4) | (ReadByte(2) & 15)) : Next
          ReadByte(2)
        Next
        FileSeek(2, Loc(2) - cols * 17)
        For c = 1 To cols
          For j = 1 To 8
            If (ReadByte(2) & 255) > 15
              If (ReadByte(2) & 255) > 15 : WriteByte(1, $FF)
              Else : WriteByte(1, $F0)
              EndIf
            ElseIf (ReadByte(2) & 255) > 15 : WriteByte(1, $0F)
            Else : WriteByte(1, $00)
            EndIf
          Next
          ReadByte(2)
        Next
        For j = 1 To pad : ReadByte(2) : Next
      Next
    Next
    FileSeek(1, 2)
    WriteLong(1, Lof(1))
    CloseFile(1)
    CloseFile(2)
    SetFileDate(f1, #PB_Date_Modified, GetFileDate(f2, #PB_Date_Modified))
    AddGadgetItem(0, -1, "(de) " + f1)
  EndIf
EndProcedure

Procedure engroutTiles2(f1.s, f2.s)
  If ReadFile(1, f1) And CreateFile(2, f2)
    ; get dimensions of the input bitmap
    FileSeek(1, $12)
    ReadLong(1)
    rows = ReadLong(1) / 8
    ; write header to output file
    WriteWord(2, $4D42) ; "BM"
    WriteLong(2, 0) ; will be file length
    WriteLong(2, 0) ; reserved
    WriteLong(2, $436) ; offset to bitmap data
    WriteLong(2, $28) ; length of header
    WriteLong(2, 8) ; width of image
    WriteLong(2, rows * 9) ; height of image
    WriteWord(2, 1) ; number of planes (= 1)
    WriteWord(2, 8) ; bits per pixel
    WriteLong(2, 0) ; no compression
    WriteLong(2, 0) ; length of bitmap data (not req'd)
    WriteLong(2, 0) ; horz-resolution (not req'd)
    WriteLong(2, 0) ; vert-resolution (not req'd)
    WriteLong(2, 0) ; colors (not req'd)
    WriteLong(2, 0) ; important colors (not req'd)
    FileSeek(1, $36) : For i = 0 To 15 : WriteLong(2, ReadLong(1)) : Next ; copy palette values from orig
    WriteLong(2, #Grid_Color) ; new grid color (entry # 16)
    For i = 17 To 255 : WriteLong(2, 0) : Next ; rest of palette is black
    For r = 1 To rows
      For i = 1 To 8 : WriteByte(2, 16) : Next
      For i = 1 To 32
        n = ReadByte(1) & 255
        WriteByte(2, n >> 4)
        WriteByte(2, n % 16)
      Next
    Next
    FileSeek(2, 2)
    WriteLong(2, Lof(2))
    CloseFile(1)
    CloseFile(2)
    SetFileDate(f2, #PB_Date_Modified, GetFileDate(f1, #PB_Date_Modified))
    AddGadgetItem(0, -1, "(en) " + f1)
  EndIf
EndProcedure

Procedure degroutTiles2(f1.s, f2.s)
  If ReadFile(2, f2) And CreateFile(1, f1)
    ; get dimensions of the input bitmap
    FileSeek(2, $12)
    ReadLong(2)
    rows = ReadLong(2) / 9
    ; write header to output file
    WriteWord(1, $4D42) ; "BM"
    WriteLong(1, 0) ; will be file length
    WriteLong(1, 0) ; reserved
    WriteLong(1, $76) ; offset to bitmap data
    WriteLong(1, $28) ; length of header
    WriteLong(1, 8) ; width of image
    WriteLong(1, rows * 8) ; height of image
    WriteWord(1, 1) ; number of planes (= 1)
    WriteWord(1, 4) ; bits per pixel
    WriteLong(1, 0) ; no compression
    WriteLong(1, 0) ; length of bitmap data (not req'd)
    WriteLong(1, 0) ; horz-resolution (not req'd)
    WriteLong(1, 0) ; vert-resolution (not req'd)
    WriteLong(1, 0) ; colors (not req'd)
    WriteLong(1, 0) ; important colors (not req'd)
    FileSeek(2, $36) : For i = 0 To 15 : WriteLong(1, ReadLong(2)) : Next ; copy palette values from orig
    FileSeek(2, $436)
    For r = 1 To rows
      For i = 1 To 8 : ReadByte(2) : Next
      For i = 1 To 32 : WriteByte(1, ((ReadByte(2) & 15) << 4) | (ReadByte(2) & 15)) : Next
    Next
    FileSeek(1, 2)
    WriteLong(1, Lof(1))
    CloseFile(1)
    CloseFile(2)
    SetFileDate(f1, #PB_Date_Modified, GetFileDate(f2, #PB_Date_Modified))
    AddGadgetItem(0, -1, "(de) " + f1)
  EndIf
EndProcedure

Procedure engroutTiles3(f1.s, f2.s)
  If ReadFile(1, f1) And CreateFile(2, f2)
    ; get dimensions of the input bitmap
    FileSeek(1, $12)
    ReadLong(1)
    rows = ReadLong(1) / 8
    ; write header to output file
    WriteWord(2, $4D42) ; "BM"
    WriteLong(2, 0) ; will be file length
    WriteLong(2, 0) ; reserved
    WriteLong(2, $436) ; offset to bitmap data
    WriteLong(2, $28) ; length of header
    WriteLong(2, 8) ; width of image
    WriteLong(2, rows * 9) ; height of image
    WriteWord(2, 1) ; number of planes (= 1)
    WriteWord(2, 8) ; bits per pixel
    WriteLong(2, 0) ; no compression
    WriteLong(2, 0) ; length of bitmap data (not req'd)
    WriteLong(2, 0) ; horz-resolution (not req'd)
    WriteLong(2, 0) ; vert-resolution (not req'd)
    WriteLong(2, 0) ; colors (not req'd)
    WriteLong(2, 0) ; important colors (not req'd)
    FileSeek(1, $36) : For i = 0 To 15 : WriteLong(2, ReadLong(1)) : Next ; copy palette values from orig
    WriteLong(2, #Background_Color) ; new background color (entry # 16)
    WriteLong(2, #Grid_Color) ; new grid color (entry # 17)
    For i = 18 To 255 : WriteLong(2, 0) : Next ; rest of palette is black
    For r = 1 To rows
      For i = 1 To 8 : WriteByte(2, 17) : Next
      For i = 1 To 8
        For j = 1 To 4
          n = ReadByte(1) & 255
          WriteByte(2, n >> 4)
          WriteByte(2, n % 16)
        Next
        FileSeek(2, Loc(2) - 8)
        For j = 1 To 4
          n = ReadByte(1) & 255
          If (n >> 4) <> 0 : WriteByte(2, 16) : Else : FileSeek(2, Loc(2) + 1) : EndIf
          If (n % 16) <> 0 : WriteByte(2, 16) : Else : FileSeek(2, Loc(2) + 1) : EndIf
        Next
      Next
    Next
    FileSeek(2, 2)
    WriteLong(2, Lof(2))
    CloseFile(1)
    CloseFile(2)
    SetFileDate(f2, #PB_Date_Modified, GetFileDate(f1, #PB_Date_Modified))
    AddGadgetItem(0, -1, "(en) " + f1)
  EndIf
EndProcedure

Procedure degroutTiles3(f1.s, f2.s)
  If CreateFile(1, f1) And ReadFile(2, f2)
    ; get dimensions of the input bitmap
    FileSeek(2, $12)
    ReadLong(2)
    rows = ReadLong(2) / 9
    ; write header to output file
    WriteWord(1, $4D42) ; "BM"
    WriteLong(1, 0) ; will be file length
    WriteLong(1, 0) ; reserved
    WriteLong(1, $76) ; offset to bitmap data
    WriteLong(1, $28) ; length of header
    WriteLong(1, 16) ; width of image
    WriteLong(1, rows * 8) ; height of image
    WriteWord(1, 1) ; number of planes (= 1)
    WriteWord(1, 4) ; bits per pixel
    WriteLong(1, 0) ; no compression
    WriteLong(1, 0) ; length of bitmap data (not req'd)
    WriteLong(1, 0) ; horz-resolution (not req'd)
    WriteLong(1, 0) ; vert-resolution (not req'd)
    WriteLong(1, 0) ; colors (not req'd)
    WriteLong(1, 0) ; important colors (not req'd)
    FileSeek(2, $36) : For i = 0 To 15 : WriteLong(1, ReadLong(2)) : Next ; copy palette values from orig
    FileSeek(2, $436)
    For r = 1 To rows
      For i = 1 To 8 : ReadByte(2) : Next
      For i = 1 To 8
        For j = 1 To 4 : WriteByte(1, ((ReadByte(2) & 15) << 4) | (ReadByte(2) & 15)) : Next
        FileSeek(2, Loc(2) - 8)
        For j = 1 To 4
          If (ReadByte(2) & 255) > 15
            If (ReadByte(2) & 255) > 15 : WriteByte(1, $FF)
            Else : WriteByte(1, $F0)
            EndIf
          ElseIf (ReadByte(2) & 255) > 15 : WriteByte(1, $0F)
          Else : WriteByte(1, $00)
          EndIf
        Next
      Next
    Next
    FileSeek(1, 2)
    WriteLong(1, Lof(1))
    CloseFile(1)
    CloseFile(2)
    SetFileDate(f1, #PB_Date_Modified, GetFileDate(f2, #PB_Date_Modified))
    AddGadgetItem(0, -1, "(de) " + f1)
  EndIf
EndProcedure

Procedure doTiles(ep)
  eps.s = Chr(ep + 48)
  f1.s = eps + "TIL0000.BMP"
  f2.s = "G" + f1
  c = compareDates(f1, f2) : If c = 2 : engroutTiles0(f1, f2) : ElseIf c = 3 : degroutTiles0(f1, f2) : EndIf
  f1 = eps + "TIL0001.BMP"
  f2 = "G" + f1
  c = compareDates(f1, f2) : If c = 2 : engroutTiles1(f1, f2) : ElseIf c = 3 : degroutTiles1(f1, f2) : EndIf
  f1 = eps + "TIL0002.BMP"
  f2 = "G" + f1
  c = compareDates(f1, f2) : If c = 2 : engroutTiles2(f1, f2) : ElseIf c = 3 : degroutTiles2(f1, f2) : EndIf
  f1 = eps + "TIL0003.BMP"
  f2 = "G" + f1
  c = compareDates(f1, f2) : If c = 2 : engroutTiles3(f1, f2) : ElseIf c = 3 : degroutTiles3(f1, f2) : EndIf
EndProcedure

Procedure engroutMaskedBitmap(f1.s, f2.s)
  If ReadFile(1, f1) And CreateFile(2, f2)
    ; get dimensions of the input bitmap
    FileSeek(1, $12)
    cols = ReadLong(1) / 2
    rows = ReadLong(1)
    ; write header to output file
    WriteWord(2, $4D42) ; "BM"
    WriteLong(2, 0) ; will be file length
    WriteLong(2, 0) ; reserved
    WriteLong(2, $436) ; offset to bitmap data
    WriteLong(2, $28) ; length of header
    WriteLong(2, cols) ; width of image
    WriteLong(2, rows) ; height of image
    WriteWord(2, 1) ; number of planes (= 1)
    WriteWord(2, 8) ; bits per pixel
    WriteLong(2, 0) ; no compression
    WriteLong(2, 0) ; length of bitmap data (not req'd)
    WriteLong(2, 0) ; horz-resolution (not req'd)
    WriteLong(2, 0) ; vert-resolution (not req'd)
    WriteLong(2, 0) ; colors (not req'd)
    WriteLong(2, 0) ; important colors (not req'd)
    FileSeek(1, $36) : For i = 0 To 15 : WriteLong(2, ReadLong(1)) : Next ; copy palette values from orig
    WriteLong(2, #Background_Color) ; new background color (entry # 16)
    For i = 17 To 255 : WriteLong(2, 0) : Next; rest of palette is black
    For r = 1 To rows
      For j = 1 To cols / 2
        n = ReadByte(1) & 255
        WriteByte(2, n >> 4)
        WriteByte(2, n % 16)
      Next
      FileSeek(2, Loc(2) - cols)
      For j = 1 To cols / 2
        n = ReadByte(1) & 255
        If (n >> 4) <> 0 : WriteByte(2, 16) : Else : FileSeek(2, Loc(2) + 1) : EndIf
        If (n % 16) <> 0 : WriteByte(2, 16) : Else : FileSeek(2, Loc(2) + 1) : EndIf
      Next
    Next
    FileSeek(2, 2)
    WriteLong(2, Lof(2))
    CloseFile(1)
    CloseFile(2)
    SetFileDate(f2, #PB_Date_Modified, GetFileDate(f1, #PB_Date_Modified))
    AddGadgetItem(0, -1, "(en) " + f1)
  EndIf
EndProcedure

Procedure degroutMaskedBitmap(f1.s, f2.s)
  If ReadFile(2, f2) And CreateFile(1, f1)
    ; get dimensions of the input bitmap
    FileSeek(2, $12)
    cols = ReadLong(2)
    rows = ReadLong(2)
    ; write header to output file
    WriteWord(1, $4D42) ; "BM"
    WriteLong(1, 0) ; will be file length
    WriteLong(1, 0) ; reserved
    WriteLong(1, $76) ; offset to bitmap data
    WriteLong(1, $28) ; length of header
    WriteLong(1, cols * 2) ; width of image
    WriteLong(1, rows) ; height of image
    WriteWord(1, 1) ; number of planes (= 1)
    WriteWord(1, 4) ; bits per pixel
    WriteLong(1, 0) ; no compression
    WriteLong(1, 0) ; length of bitmap data (not req'd)
    WriteLong(1, 0) ; horz-resolution (not req'd)
    WriteLong(1, 0) ; vert-resolution (not req'd)
    WriteLong(1, 0) ; colors (not req'd)
    WriteLong(1, 0) ; important colors (not req'd)
    FileSeek(2, $36) : For i = 0 To 15 : WriteLong(1, ReadLong(2)) : Next ; copy palette values from orig
    FileSeek(2, $436)
    For r = 1 To rows
      For c = 1 To cols / 2 : WriteByte(1, ((ReadByte(2) & 15) << 4) | (ReadByte(2) & 15)) : Next
      FileSeek(2, Loc(2) - cols)
      For c = 1 To cols / 2
        If (ReadByte(2) & 255) > 15
          If (ReadByte(2) & 255) > 15 : WriteByte(1, $FF)
          Else : WriteByte(1, $F0)
          EndIf
        ElseIf (ReadByte(2) & 255) > 15 : WriteByte(1, $0F)
        Else : WriteByte(1, $00)
        EndIf
      Next
    Next
    FileSeek(1, 2)
    WriteLong(1, Lof(1))
    CloseFile(1)
    CloseFile(2)
    SetFileDate(f1, #PB_Date_Modified, GetFileDate(f2, #PB_Date_Modified))
    AddGadgetItem(0, -1, "(de) " + f1)
  EndIf
EndProcedure

Procedure doMaskedBitmap(ep, n)
  eps.s = Chr(ep + 48)
  f1.s = eps + "MBM" + RSet(Str(n), 4, "0") + ".BMP"
  f2.s = "G" + f1
  c = compareDates(f1, f2) : If c = 0 : ProcedureReturn 1 : ElseIf c = 2 : engroutMaskedBitmap(f1, f2) : ElseIf c = 3 : degroutMaskedBitmap(f1, f2) : EndIf
EndProcedure

Procedure engroutSprite(f1.s, f2.s)
  If ReadFile(1, f1) And CreateFile(2, f2)
    ; get dimensions of the input bitmap
    FileSeek(1, $12)
    cols = ReadLong(1) / 3
    rows = ReadLong(1)
    ; write header to output file
    WriteWord(2, $4D42) ; "BM"
    WriteLong(2, 0) ; will be file length
    WriteLong(2, 0) ; reserved
    WriteLong(2, $436) ; offset to bitmap data
    WriteLong(2, $28) ; length of header
    WriteLong(2, cols * 2) ; width of image
    WriteLong(2, rows) ; height of image
    WriteWord(2, 1) ; number of planes (= 1)
    WriteWord(2, 8) ; bits per pixel
    WriteLong(2, 0) ; no compression
    WriteLong(2, 0) ; length of bitmap data (not req'd)
    WriteLong(2, 0) ; horz-resolution (not req'd)
    WriteLong(2, 0) ; vert-resolution (not req'd)
    WriteLong(2, 0) ; colors (not req'd)
    WriteLong(2, 0) ; important colors (not req'd)
    FileSeek(1, $36) : For i = 0 To 15 : WriteLong(2, ReadLong(1)) : Next ; copy palette values from orig
    WriteLong(2, #Background_Color) ; new background color (entry # 16)
    For i = 17 To 255 : WriteLong(2, 0) : Next; rest of palette is black
    For r = 1 To rows
      For j = 1 To cols / 2
        n = ReadByte(1) & 255
        WriteByte(2, n >> 4)
        WriteByte(2, n % 16)
      Next
      FileSeek(2, Loc(2) - cols)
      For j = 1 To cols / 2
        n = ReadByte(1) & 255
        If (n >> 4) <> 0 : WriteByte(2, 16) : Else : FileSeek(2, Loc(2) + 1) : EndIf
        If (n % 16) <> 0 : WriteByte(2, 16) : Else : FileSeek(2, Loc(2) + 1) : EndIf
      Next
      For j = 1 To cols / 2
        n = ReadByte(1) & 255
        WriteByte(2, n >> 4)
        WriteByte(2, n % 16)
      Next
    Next
    FileSeek(2, 2)
    WriteLong(2, Lof(2))
    CloseFile(1)
    CloseFile(2)
    SetFileDate(f2, #PB_Date_Modified, GetFileDate(f1, #PB_Date_Modified))
    AddGadgetItem(0, -1, "(en) " + f1)
  EndIf
EndProcedure

Procedure degroutSprite(f1.s, f2.s)
  If ReadFile(2, f2) And CreateFile(1, f1)
    ; get dimensions of the input bitmap
    FileSeek(2, $12)
    cols = ReadLong(2) / 2
    rows = ReadLong(2)
    ; write header to output file
    WriteWord(1, $4D42) ; "BM"
    WriteLong(1, 0) ; will be file length
    WriteLong(1, 0) ; reserved
    WriteLong(1, $76) ; offset to bitmap data
    WriteLong(1, $28) ; length of header
    WriteLong(1, cols * 3) ; width of image
    WriteLong(1, rows) ; height of image
    WriteWord(1, 1) ; number of planes (= 1)
    WriteWord(1, 4) ; bits per pixel
    WriteLong(1, 0) ; no compression
    WriteLong(1, 0) ; length of bitmap data (not req'd)
    WriteLong(1, 0) ; horz-resolution (not req'd)
    WriteLong(1, 0) ; vert-resolution (not req'd)
    WriteLong(1, 0) ; colors (not req'd)
    WriteLong(1, 0) ; important colors (not req'd)
    FileSeek(2, $36) : For i = 0 To 15 : WriteLong(1, ReadLong(2)) : Next ; copy palette values from orig
    FileSeek(2, $436)
    For r = 1 To rows
      For c = 1 To cols / 2 : WriteByte(1, ((ReadByte(2) & 15) << 4) | (ReadByte(2) & 15)) : Next
      FileSeek(2, Loc(2) - cols)
      For c = 1 To cols / 2
        If (ReadByte(2) & 255) > 15
          If (ReadByte(2) & 255) > 15 : WriteByte(1, $FF)
          Else : WriteByte(1, $F0)
          EndIf
        ElseIf (ReadByte(2) & 255) > 15 : WriteByte(1, $0F)
        Else : WriteByte(1, $00)
        EndIf
      Next
      For c = 1 To cols / 2 : WriteByte(1, ((ReadByte(2) & 15) << 4) | (ReadByte(2) & 15)) : Next
    Next
    FileSeek(1, 2)
    WriteLong(1, Lof(1))
    CloseFile(1)
    CloseFile(2)
    SetFileDate(f1, #PB_Date_Modified, GetFileDate(f2, #PB_Date_Modified))
    AddGadgetItem(0, -1, "(de) " + f1)
  EndIf
EndProcedure

Procedure doSprite(ep, n)
  eps.s = Chr(ep + 48)
  f1.s = eps + "SPR" + RSet(Str(n), 4, "0") + ".BMP"
  f2.s = "G" + f1
  c = compareDates(f1, f2) : If c = 0 : ProcedureReturn 1 : ElseIf c = 2 : engroutSprite(f1, f2) : ElseIf c = 3 : degroutSprite(f1, f2) : EndIf
EndProcedure

If OpenWindow(0, #PB_Ignore, #PB_Ignore, 250, 150, "KeenGrout", #PB_Window_SystemMenu | #PB_Window_SizeGadget) And CreateGadgetList(WindowID(0))
  StickyWindow(0, 1)
  SmartWindowRefresh(0, 1)
  EditorGadget(0, 5, 5, #PB_Ignore, #PB_Ignore, #PB_Editor_ReadOnly)
  GadgetToolTip(0, "Reports the results of the latest sync operation.")
  ButtonGadget(1, #PB_Ignore, #PB_Ignore, 50, 30, "Sync")
  GadgetToolTip(1, "Sync the normal and grouted versions of the graphics.")
  LoadFont(0, "COURIER NEW", 9)
  SetGadgetFont(0, FontID(0))
  Repeat
    Select WaitWindowEvent()
      Case #PB_Event_Gadget
        Select EventGadget()
          Case 1
            ClearGadgetItemList(0)
            DisableGadget(1, 1)
            For ep = 1 To 6
              doTiles(ep)
              n = -1 : Repeat : n = n + 1 : Until doMaskedBitmap(ep, n)
              n = -1 : Repeat : n = n + 1 : Until doSprite(ep, n)
            Next
            AddGadgetItem(0, -1, "Both versions are up to date.")
            DisableGadget(1, 0)
        EndSelect
      Case #PB_Event_SizeWindow
        ResizeGadget(0, #PB_Ignore, #PB_Ignore, WindowWidth(0) - 10, WindowHeight(0) - 45)
        ResizeGadget(1, WindowWidth(0) / 2 - 25, WindowHeight(0) - 35, #PB_Ignore, #PB_Ignore)
      Case #PB_Event_CloseWindow
        Break
    EndSelect
  ForEver
EndIf
